* c25.for
* Original Program : Program C2.5 in N88BASIC
* written by Ktsumi Sakurai
* ported by Kenrou Adachi, 2004

* motion in central force of f(r)=a*r^n

$notruncate

      program  c25

      real x, y, y1, vx, vy, a, t, h
      integer*2 cpx ,cpy

      call ginit
      call setcolor(3)
      call circle(200, 200, 5)
      call setcolor(2)
      call line( 20,  20, 380,  20)
      call line( 20,  20,  20, 380)
      call line( 20, 380, 380, 380)
      call line(380,  20, 380, 380)

*     write(*,*) 'input a of f(r)=a*r^3'
*     read(*,*) a
      a = 2.0

      y  = -18.0
      y1 = y

      do 10 j = 1, 72
	vx = 1.0
        vy = 0.0 
        x = -20.0
        y = y1
	t = 0.0
        h = 0.5

	call moveto(int(9.0 * x) + 200, -int(9.0 * y) + 200)

        call setcolor(6)
	call runge(x, y, vx, vy, a, t, h)
	y1 = y1 + 0.5
   10 continue

      call fkeyon
      call cursoron

      stop
      end


      real function tri(e)
      real e

      tri = e * e * e

      return
      end


      real function fx(vx0)
      real vx0

      fx = vx0

      return
      end


      real function gx(x0, y0, a0)
      real x0, y0, a0

      gx = a0 * x0 / sqrt(tri(x0 * x0 + y0 * y0))

      return
      end


      real function fy(vy0)
      real vy0

      fy = vy0

      return
      end


      real function gy(x0, y0, a0)
      real x0, y0, a0

      gy = a0 * y0 / sqrt(tri(x0 * x0 + y0 * y0))

      return
      end


      subroutine runge(x, y, vx, vy, a, t, h)
      real x, y, vx, vy, a, t, h

      real kx1,kx2,kx3,kx4,lx1,lx2,lx3,lx4
      real ky1,ky2,ky3,ky4,ly1,ly2,ly3,ly4
      integer*2 i, dpx, dpy

      do 20 i = 0, 2000

        dpx = int(9.0 * x) + 200
        dpy = -int(9.0 * y) + 200
        call lineto(dpx, dpy)
      
        kx1 = h * fx(vx)
        lx1 = h * gx(x, y, a)
        kx2 = h * fx(vx + lx1 / 2.0)
        lx2 = h * gx(x + kx1 / 2.0, y, a)
        kx3 = h * fx(vx + lx2 / 2.0)
        lx3 = h * gx(x + kx2 / 2.0, y, a)
        kx4 = h * fx(vx + lx3)
        lx4 = h * gx(x + kx3, y ,a)
        x   = x  + (kx1 + 2.0 * kx2 + 2.0 * kx3 + kx4) / 6.0
        vx  = vx + (lx1 + 2.0 * lx2 + 2.0 * lx3 + lx4) / 6.0

        ky1 = h * fy(vy)
        ly1 = h * gy(x, y, a)
	ky2 = h * fy(vy + ly1 / 2.0)
        ly2 = h * gy(x, y + ky1 / 2.0, a)
	ky3 = h * fy(vy + ly2 / 2.0)
        ly3 = h * gy(x, y + ky2 / 2.0, a)
	ky4 = h * fy(vy + ly3)
        ly4 = h * gy(x, y + ky3, a)
	y   = y  + (ky1 + 2.0 * ky2 + 2.0 * ky3 + ky4) / 6.0
	vy  = vy + (ly1 + 2.0 * ly2 + 2.0 * ly3 + ly4) / 6.0

        t = t + h

	if ((abs(x).gt.20.0).or.(abs(y).gt.20.0)) goto 30

   20 continue

   30 continue

      return
      end
