; MS-FORTRAN (NEC PC-9801) Graphics Library
; Copylefted by Kenrou Adachi, 1993
;
NAME GLIOASM
;
;
PUSHALL MACRO
;
        PUSH    AX
        PUSH    BX
        PUSH    CX
        PUSH    DX
        PUSH    BP
        PUSH    SI
        PUSH    DI
        PUSH    DS
        PUSH    ES
        PUSHF
;
        ENDM
;
POPALL  MACRO
;
        POPF
        POP     ES
        POP     DS
        POP     DI
        POP     SI
        POP     BP
        POP     DX
        POP     CX
        POP     BX
        POP     AX
;
        ENDM
;
;
;
PUBLIC WORK_GLIO,WORK_PAI_BEGIN,WORK_PAI_END
PUBLIC INT_A0AF,INT_CE,INT_C5
;
C_INITG SEGMENT 'CODE'
   ASSUME CS:C_INITG,DS:C_INITG,ES:C_INITG
;
;*** define work area ***
;
     WORK_GLIO        DB 1400H DUP(0)
     WORK_PAI_BEGIN   DB  400H DUP(0)
     WORK_PAI_END     DB   00H
;
     INT_A0AF         DD   10H DUP(0)
     INT_CE           DD    0H
;
     INT_C5           DD    0H
;
;
PUBLIC GGINIT
  GGINIT PROC FAR
;
     PUSHALL
;
     MOV BP,SP
     PUSH BP
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     CLI
;
     PUSH    DS
;
;**** save interrupt vectors ****
;
     MOV AX,DS
     MOV ES,AX
     MOV DI,OFFSET INT_A0AF
     MOV AX,00H
     MOV DS,AX
     MOV SI,0A0H*4
     CLD
     MOV CX,20H
     REP MOVSW
;
     MOV SI,0CEH*4
     MOVSW
     MOVSW
;
;**** save stop check vector ****
;
     MOV SI,0C5H*4
     MOVSW
     MOVSW
;
;**** set interrupt vectors for graphic LIO ****
     MOV AX,0F990H
     MOV DS,AX
     MOV SI,06H
     MOV AX,00H
     MOV ES,AX
     MOV DI,0A0H*4
     MOV CX,10H
     MOV AX,0F990H
LINITG_1:
     MOVSW
     STOSW
     ADD SI,02H
     LOOP LINITG_1
;
     MOV DI,0CEH*4
     MOVSW
     STOSW
;
;**** set interrupt vector for stop check ****
;
     MOV DI,0C5H*4
     MOV AX,OFFSET STOP_CHECK
     STOSW
     MOV ES:[DI],CS
;
     POP DS
;
     STI
;
     INT 0A0H
;
     POP BP
     LES DI,DWORD PTR SS:18H[BP]
     MOV BYTE PTR ES:18H[DI],AH
;
     POPALL
     RET 4
;
STOP_CHECK:
     IRET
;
  GGINIT ENDP
C_INITG ENDS
;
;
SC_ARG_AS STRUC
    MODE DB ?
    MSWT DB ?
    MACT DB ?
    MDSP DB ?
SC_ARG_AS ENDS
;
C_SCREEN SEGMENT 'CODE'
  ASSUME CS:C_SCREEN
PUBLIC GSCREEN
  GSCREEN PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** set display mode ****
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].MODE,AL
;
;**** set display switch ****
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].MSWT,AL
;
;**** set active page ****
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].MACT,AL
;
;**** set display page ****
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].MDSP,AL
;
     PUSH BP
;
     MOV BX,00H
     INT 0A1H
;
     POP BP
;
;**** get error code IERR *****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 20
;
  GSCREEN ENDP
;
  C_SCREEN ENDS
;
;
GV_ARG_AS STRUC
    VIX1 DW ?
    VIY1 DW ?
    VIX2 DW ?
    VIY2 DW ?
    VDCL DB ?
    VBCL DB ?
GV_ARG_AS ENDS
;
C_VIEW SEGMENT 'CODE'
  ASSUME CS:C_VIEW
PUBLIC GVIEW
  GVIEW PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** set parameters ****
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].VIX1,AX
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].VIY1,AX
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].VIX2,AX
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].VIY2,AX
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].VDCL,AL
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].VBCL,AL
;
     PUSH BP
;
     MOV BX,00H
     INT 0A2H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 28
;
  GVIEW ENDP
;
C_VIEW ENDS
;
;
GCOL_ARG_AS STRUC
    CDUMY DB ?
    CBCL DB ?
    CBDL DB ?
    CFCL DB ?
    CPMD DB ?
GCOL_ARG_AS ENDS
;
C_COLOR SEGMENT 'CODE'
  ASSUME CS:C_COLOR
PUBLIC GCOLOR
  GCOLOR PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** set parameters ****
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CDUMY,AL
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CBCL,AL
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CBDL,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CFCL,AL
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CPMD,AL
;
     PUSH BP
;
     MOV BX,00H
     INT 0A3H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 24
;
  GCOLOR ENDP
;
C_COLOR ENDS
;
;
;
GPAL_ARG_AS STRUC
    PLPL DB ?
    CDE1 DB ?
    CDE2 DW ?
GPAL_ARG_AS ENDS
;
C_PALETTE SEGMENT 'CODE'
  ASSUME CS:C_PALETTE
;
PUBLIC GPALETTE
  GPALETTE PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** set parameters ****
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PLPL,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CDE1,AL
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CDE2,AX
;
     PUSH BP
;
     MOV BX,00H
     INT 0A4H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 16
;
  GPALETTE ENDP
;
C_PALETTE ENDS
;
;
C_GCLS SEGMENT 'CODE'
  ASSUME CS:C_GCLS
PUBLIC GCLS
  GCLS PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
;
     PUSH BP
;
     INT 0A5H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 4
;
  GCLS ENDP
;
C_GCLS ENDS
;
;
;
PSET_ARG_AS STRUC
    PSX DW ?
    PSY DW ?
    PSCL DB ?
PSET_ARG_AS ENDS
;
C_PSET SEGMENT 'CODE'
  ASSUME CS:C_PSET
;
PUBLIC GPSET
  GPSET PROC FAR
;
  PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** set parameters ****
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PSX,AX
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PSY,AX
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PSCL,AL
;
     PUSH BP;
;
     MOV AH,01H
     MOV BX,00H
     INT 0A6H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 16
;
  GPSET ENDP
;
C_PSET ENDS
;
;
;
GL_ARG_AS STRUC
    LIX1 DW ?
    LIY1 DW ?
    LIX2 DW ?
    LIY2 DW ?
    LPAL DB ?
    LCODE DW ?
    LPNO  DB ?
    LPDUM DB ?
    LPTN  DB ?
    LIOF  DW ?
    LISG  DW ?
GL_ARG_AS ENDS
;
C_LINE SEGMENT 'CODE'
  ASSUME CS:C_LINE
PUBLIC GLINE
  GLINE PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** parameters ****
;
     LES DI,DWORD PTR SS:2CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LIX1,AX
;
     LES DI,DWORD PTR SS:28H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LIY1,AX
;
     LES DI,DWORD PTR SS:24H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LIX2,AX
;
     LES DI,DWORD PTR SS:20H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LIY2,AX
;
     LES DI,DWORD PTR SS:1CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LPAL,AL
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LCODE,AX
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LPNO,AL
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LPDUM,AL
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LPTN,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LIOF,AX
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].LISG,AX
;
     PUSH BP
;
     MOV BX,00H
     INT 0A7H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 48
;
   GLINE ENDP
;
C_LINE ENDS
;
;
;
CIRC_ARG_AS STRUC
    CICX DW ?
    CICY DW ?
    CIRX DW ?
    CIRY DW ?
    CIPL DB ?
    CISW DB ?
    CISX DW ?
    CISY DW ?
    CIEX DW ?
    CIEY DW ?
    CIBP DB ?
    CIOF DW ?
    CISG DW ?
CIRC_ARG_AS ENDS
;
C_CIRCLE SEGMENT 'CODE'
  ASSUME CS:C_CIRCLE
;
PUBLIC GCIRCLE
  GCIRCLE PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** parameters ****
;
     LES DI,DWORD PTR SS:34H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CICX,AX
;
     LES DI,DWORD PTR SS:30H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CICY,AX
;
     LES DI,DWORD PTR SS:2CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CIRX,AX
;
     LES DI,DWORD PTR SS:28H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CIRY,AX
;
     LES DI,DWORD PTR SS:24H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CIPL,AL
;
     LES DI,DWORD PTR SS:20H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CISW,AL
;
     LES DI,DWORD PTR SS:1CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CISX,AX
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CISY,AX
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CIEX,AX
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CIEY,AX
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CIBP,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CIOF,AX
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].CISG,AX
;
     PUSH BP
;
     MOV BX,00H
     INT 0A8H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 56
;
  GCIRCLE ENDP
;
C_CIRCLE ENDS
;
;
;
P1_ARG_AS STRUC
    P1X  DW ?
    P1Y  DW ?
    P1DC DB ?
    P1BC DB ?
    P1OF DW ?
    P1SG DW ?
P1_ARG_AS ENDS
;
C_PAINT1 SEGMENT 'CODE'
  ASSUME CS:C_PAINT1
;
PUBLIC GPAINT1
  GPAINT1 PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** set parameters ****
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P1X,AX
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P1Y,AX
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P1DC,AL
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P1BC,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P1OF,AX
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P1SG,AX
;
     PUSH BP
;
     MOV BX,00H
     INT 0A9H
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 28
;
  GPAINT1 ENDP
;
C_PAINT1 ENDS
;
;
;
P2_ARG_AS STRUC
    P2X   DW ?
    P2Y   DW ?
    PDUM0 DB ?
    P2PLN DB ?
    P2TOF DW ?
    P2TSG DW ?
    P2BC  DB ?
    PDUM1 DW ?
    PDUM2 DW ?
    PDUM3 DB ?
    P2OFF DW ?
    P2SEG DW ?
P2_ARG_AS ENDS
;
C_PAINT2 SEGMENT 'CODE'
  ASSUME CS:C_PAINT2
;
PUBLIC GPAINT2
  GPAINT2 PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** parameters ****
;
     LES DI,DWORD PTR SS:30H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2X,AX
;
     LES DI,DWORD PTR SS:2CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2Y,AX
;
     LES DI,DWORD PTR SS:28H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PDUM0,AL
;
     LES DI,DWORD PTR SS:24H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2PLN,AL
;
     LES DI,DWORD PTR SS:20H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2TOF,AX
;
     LES DI,DWORD PTR SS:1CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2TSG,AX
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2BC,AL
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PDUM1,AX
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PDUM2,AX
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PDUM3,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2OFF,AX
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].P2SEG,AX
;
     PUSH BP
;
     MOV BX,00H
     INT 0AAH
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 52
;
  GPAINT2 ENDP
;
C_PAINT2 ENDS
;
;
;
GGET_ARG_AS STRUC
    GTX1 DW ?
    GTY1 DW ?
    GTX2 DW ?
    GTY2 DW ?
    GTOF DW ?
    GTSG DW ?
    GTLN DW ?
GGET_ARG_AS ENDS
;
C_GET SEGMENT 'CODE'
  ASSUME CS:C_GET
;
PUBLIC GGET
  GGET PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** parameters ****
;
     LES DI,DWORD PTR SS:1CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].GTX1,AX
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].GTY1,AX
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].GTX2,AX
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].GTY2,AX
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].GTOF,AX
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].GTSG,AX
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].GTLN,AX
;
     PUSH BP
;
     MOV BX,00H
     INT 0ABH
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 32
;
  GGET ENDP
;
C_GET ENDS
;
;
;
PUT1_ARG_AS STRUC
    PIX0 DW ?
    PIY0 DW ?
    PIOFF DW ?
    PISEG DW ?
    PILEN DW ?
    PIMOD DB ?
    PISWT DB ?
    PIPLW DB ?
    PIPLB DB ?
PUT1_ARG_AS ENDS
;
C_PUT1 SEGMENT 'CODE'
  ASSUME CS:C_PUT1
;
PUBLIC GPUT1
  GPUT1 PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** parameters ****
;
     LES DI,DWORD PTR SS:24H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PIX0,AX
;
     LES DI,DWORD PTR SS:20H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PIY0,AX
;
     LES DI,DWORD PTR SS:1CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PIOFF,AX
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PISEG,AX
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PILEN,AX
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PIMOD,AL
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PISWT,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PIPLW,AL
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PIPLB,AL
;
     PUSH BP
;
     MOV BX,00H
     INT 0ACH
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 40
;
  GPUT1 ENDP
;
C_PUT1 ENDS
;
;
;
PUT2_ARG_AS STRUC
    PKX  DW ?
    PKY  DW ?
    PKJC DW ?
    PKMD DB ?
    PKSW DB ?
    PKPW DB ?
    PKPB DB ?
PUT2_ARG_AS ENDS
;
C_PUT2 SEGMENT 'CODE'
  ASSUME CS:C_PUT2
;
PUBLIC GPUT2
  GPUT2 PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** parameters ****
;
     LES DI,DWORD PTR SS:1CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PKX,AX
;
     LES DI,DWORD PTR SS:18H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PKY,AX
;
     LES DI,DWORD PTR SS:14H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PKJC,AX
;
     LES DI,DWORD PTR SS:10H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PKMD,AL
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PKSW,AL
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PKPW,AL
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].PKPB,AL
;
     PUSH BP
;
     MOV BX,00H
     INT 0ADH
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 32
;
  GPUT2 ENDP
;
C_PUT2 ENDS
;
;
;
ROL_ARG_AS STRUC
    ROLX DW ?
    ROLY DW ?
    ROLF DB ?
ROL_ARG_AS ENDS
;
C_ROLL SEGMENT 'CODE'
  ASSUME CS:C_ROLL
;
PUBLIC GROLL
  GROLL PROC FAR
;
     PUSHALL
;
     MOV AX,SEG WORK_GLIO
     MOV DS,AX
;
     MOV BP,SP
     ADD BP,18H
;
;**** parameters ****
;
     LES DI,DWORD PTR SS:0CH[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].ROLX,AX
;
     LES DI,DWORD PTR SS:08H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].ROLY,AX
;
     LES DI,DWORD PTR SS:04H[BP]
     MOV AX,WORD PTR ES:[DI]
     MOV DS:[00].ROLF,AL
;
     PUSH BP
;
     MOV BX,00H
     INT 0AEH
;
     POP BP
;
;**** get error code IERR ****
;
     LES DI,DWORD PTR SS:00H[BP]
     MOV BYTE PTR ES:[DI],AH
;
     POPALL
     RET 16
;
 GROLL ENDP
;
C_ROLL ENDS
;
;
;
END

