c     MS-FORTRAN (NEC PC-9801) Graphics Library
c     Copyleft Kenrou Adachi, 1993
c     turtle.for

$notruncate

      subroutine setlp(lpx, lpy)
      real lpx, lpy

      real LLPX, LLPY, AANGLE
      common /tdata/ LLPX, LLPY, AANGLE

      LLPX = lpx
      LLPY = lpy

      return
      end

      subroutine setangle(ang)
      real ang

      real LLPX,LLPY,AANGLE
      common /tdata/ LLPX, LLPY, AANGLE

      AANGLE = ang

      return
      end

      subroutine turn(ang)
      real ang

      real LLPX, LLPY, AANGLE
      common /tdata/ LLPX, LLPY, AANGLE

      AANGLE = AANGLE + ang
      AANGLE = AANGLE - int(AANGLE) + mod(int(AANGLE), 360)

      return
      end


      subroutine warp(leng)
      real leng

      real LLPX, LLPY, AANGLE, PI
      common /tdata/ LLPX, LLPY, AANGLE
      data PI /3.1415927/

      LLPX = LLPX + leng * cos(AANGLE * PI / 180)
      LLPY = LLPY - leng * sin(AANGLE * PI / 180)

      return
      end

      subroutine move(leng)
      real leng

      real LLPX,LLPY,AANGLE,PI
      common /tdata/ LLPX, LLPY, AANGLE
      real x, y
      data PI /3.1415927/

      x = LLPX + leng * cos(AANGLE * PI / 180)
      y = LLPY - leng * sin(AANGLE * PI / 180)
      call line(int(LLPX), int(LLPY), int(x), int(y))

      return

      end
