c     MS-FORTRAN (NEC PC-9801) Graphics Library
c     Copyleft Kenrou Adachi
c     ginit.for

$notruncate

      subroutine ginit

      integer*2 ierr

      call gginit(ierr)
      call setscreenmode(1, 0)
      call setcolormode(0, 7)
      call setscreenmode(0, 0)
      call setcolormode(0, 7)
      call cleartextscreen
      call fkeyoff
      call cursoroff

      return
      end



      subroutine setscreenmode(act, vis)
      integer*2 act, vis

      integer*2 dp, ierr
      integer*2 ACT_PAGE, VIS_PAGE
      common /selpage/ ACT_PAGE, VIS_PAGE

      ACT_PAGE = act
      VIS_PAGE = vis
      if (vis .eq. 0) then
          dp = 1
      else
          dp = 33
      end if
      call gscreen(3, 0, act, dp, ierr)

      return
      end



      subroutine setcolormode(bkc, frc)
      integer*2 bkc, frc

      integer*2 BK_COLOR, FR_COLOR, ierr
      common /selcol/ BK_COLOR, FR_COLOR

      BK_COLOR = bkc
      FR_COLOR = frc
      call gcolor(0, bkc, 0, frc, 2, ierr)
      call gcls(ierr)

      return
      end
