c     MS-FORTRAN (NEC PC-9801) Graphics Library
c     Copyleft Kenrou Aadchi, 1993
c     setdata.for

$notruncate

      subroutine set0(x0, y0, k)
      integer*2 x0, y0, k

      integer*2 Y_FLAG, X_0, Y_0
      real Y_SCALE
      common /yaxis/ Y_FLAG, Y_SCALE
      common /setp/  X_0, Y_0

      X_0 = x0
      Y_0 = y0
      Y_FLAG = k

      return
      end


      subroutine setyscale(scale)
      real scale

      real Y_SCALE
      integer*2 Y_FLAG
      common /yaxis/ Y_FLAG, Y_SCALE

      Y_SCALE = scale

      return
      end


      subroutine setcolor(drc)
      integer*2 drc

      integer*2 DRAW_COLOR
      common /p_col/ DRAW_COLOR

      DRAW_COLOR = drc

      return
      end


      subroutine setlinepattern(lpt)
      integer*2 lpt

      integer*2 LINE_SW, RECT_SW, LINE_PTN
      common /geosw1/ LINE_SW, RECT_SW
      common /lptn/   LINE_PTN

      LINE_SW = #0100
      RECT_SW = #0101
      LINE_PTN = lpt

      return
      end


      subroutine setfillcolor(flc)
      integer*2 flc

      integer*2 LINE_SW, RECT_SW, CIRC_SW, PIE_SW, LINE_PTN
      integer*2 FILL_PTN_SIZE, FILL_PTN_OFF, FILL_SW
      integer*2 FILL_PTN_SEG
      common /geosw1/ LINE_SW, RECT_SW
      common /geosw2/ CIRC_SW, PIE_SW
      common /lptn/   LINE_PTN
      common /paint1/ FILL_SW
      common /paint2/ FILL_PTN_SIZE, FILL_PTN_OFF, FILL_PTN_SEG

      if(flc .ge. 0 .and. flc .le. 15) then
          RECT_SW = #0102
          CIRC_SW = #20
          PIE_SW = #2f
          LINE_PTN = flc
          FILL_PTN_SIZE = flc
      else
          RECT_SW = #0002
          CIRC_SW = #20
          PIE_SW = #2f
          LINE_PTN = #ffff
          FILL_PTN_SIZE = #ff
      end if
      FILL_SW = 0

      return
      end


      subroutine setfillpattern(size, dat)
      integer*2 size
      integer*1 dat(*)

      integer*2 LINE_SW, RECT_SW, CIRC_SW, PIE_SW
      integer*2 FILL_PTN_SIZE, FILL_PTN_OFF, FILL_SW
      integer*2 FILL_PTN_SEG
      common /geosw1/ LINE_SW, RECT_SW
      common /geosw2/ CIRC_SW, PIE_SW
      common /paint1/ FILL_SW
      common /paint2/ FILL_PTN_SIZE, FILL_PTN_OFF, FILL_PTN_SEG

      RECT_SW = #0202
      CIRC_SW = #60
      PIE_SW = #6f
      FILL_SW = 1
      FILL_PTN_SIZE = size
      FILL_PTN_OFF = lower16(LOCFAR(dat))
      FILL_PTN_SEG = higher16(LOCFAR(dat))

      return
      end
